import { createGroup as publicCreateGroup, updateGroup as publicUpdateGroup, deleteGroup as publicDeleteGroup, getGroup as publicGetGroup, getGroupBySlug as publicGetGroupBySlug, listGroups as publicListGroups, queryGroups as publicQueryGroups } from './social-groups-v2-group-groups.public.js';
import { createEventModule } from '@wix/sdk-runtime/event-definition-modules';
import { BuildRESTFunction, MaybeContext } from '@wix/sdk-types';
import { onGroupCreated as publicOnGroupCreated } from './social-groups-v2-group-groups.public.js';
import { onGroupDeleted as publicOnGroupDeleted } from './social-groups-v2-group-groups.public.js';
import { onGroupCoverChanged as publicOnGroupCoverChanged } from './social-groups-v2-group-groups.public.js';
import { onGroupDescriptionChanged as publicOnGroupDescriptionChanged } from './social-groups-v2-group-groups.public.js';
import { onGroupUpdated as publicOnGroupUpdated } from './social-groups-v2-group-groups.public.js';
export declare const createGroup: MaybeContext<BuildRESTFunction<typeof publicCreateGroup> & typeof publicCreateGroup>;
export declare const updateGroup: MaybeContext<BuildRESTFunction<typeof publicUpdateGroup> & typeof publicUpdateGroup>;
export declare const deleteGroup: MaybeContext<BuildRESTFunction<typeof publicDeleteGroup> & typeof publicDeleteGroup>;
export declare const getGroup: MaybeContext<BuildRESTFunction<typeof publicGetGroup> & typeof publicGetGroup>;
export declare const getGroupBySlug: MaybeContext<BuildRESTFunction<typeof publicGetGroupBySlug> & typeof publicGetGroupBySlug>;
export declare const listGroups: MaybeContext<BuildRESTFunction<typeof publicListGroups> & typeof publicListGroups>;
export declare const queryGroups: MaybeContext<BuildRESTFunction<typeof publicQueryGroups> & typeof publicQueryGroups>;
/**
 * Triggered when a group is created.
 */
export declare const onGroupCreated: ReturnType<typeof createEventModule<typeof publicOnGroupCreated>>;
/**
 * Triggered when a group is deleted.
 */
export declare const onGroupDeleted: ReturnType<typeof createEventModule<typeof publicOnGroupDeleted>>;
/**
 * Triggered when a group's logo is changed.
 */
export declare const onGroupCoverChanged: ReturnType<typeof createEventModule<typeof publicOnGroupCoverChanged>>;
/**
 * Triggered when a group's description is changed.
 */
export declare const onGroupDescriptionChanged: ReturnType<typeof createEventModule<typeof publicOnGroupDescriptionChanged>>;
/**
 * Triggered when a group is updated. See payload for more information about the specific trigger.
 */
export declare const onGroupUpdated: ReturnType<typeof createEventModule<typeof publicOnGroupUpdated>>;
export { Type, AllowPolicy, StepKey, PrivacyStatus, IdentityType, ContentType, SortOrder, MembershipStatus, BMFeaturesBMFeatures, WebhookIdentityType, } from './social-groups-v2-group-groups.universal.js';
export { Group, Events, Logo, GroupDetailsPosition, Image, Position, OnboardingStepSettings, AccessRestriction, AccessRestrictionDataOneOf, GroupDetails, CoverImage, GroupSettings, Identity, CreateGroupRequest, CreateGroupResponse, UpdateGroupRequest, UpdateGroupResponse, GroupCoverChanged, GroupDescriptionChanged, DeleteGroupRequest, DeleteGroupResponse, GetGroupRequest, GetGroupResponse, GetGroupBySlugRequest, GetGroupBySlugResponse, GetGroupIdBySlugRequest, GetGroupIdBySlugResponse, GlobalFeedPermissions, FeedPermissions, FeedItemPermissions, ListGroupsRequest, ListGroupsResponse, PagingMetadata, ListGroupsByUserIdRequest, ListGroupsByUserIdResponse, GroupWithMsId, QueryGroupsRequest, Query, Sorting, Paging, QueryGroupsResponse, QueryJoinedGroupsRequest, QueryJoinedGroupsResponse, QueryGroupsByMembershipRequest, GroupPermissions, QueryGroupsByMembershipResponse, ListGroupIntegrationsDataRequest, ListGroupIntegrationsDataResponse, GroupIntegrationsData, GetGroupMembersGroupIdsRequest, GetGroupMembersGroupIdsResponse, GetGroupBMFeaturesRequest, GetGroupBMFeaturesResponse, BMFeatures, QueryJoinedGroupsWithMemberRequest, QueryJoinedGroupsWithMemberResponse, GetPrivacyRequest, GetPrivacyResponse, DomainEvent, DomainEventBodyOneOf, EntityCreatedEvent, RestoreInfo, EntityUpdatedEvent, EntityDeletedEvent, ActionEvent, MessageEnvelope, IdentificationData, IdentificationDataIdOneOf, BaseEventMetadata, EventMetadata, GroupCreatedEnvelope, GroupDeletedEnvelope, GroupCoverChangedEnvelope, GroupDescriptionChangedEnvelope, GroupUpdatedEnvelope, CreateGroupOptions, UpdateGroup, UpdateGroupOptions, GetGroupOptions, GetGroupBySlugOptions, ListGroupsOptions, QueryGroupsOptions, GroupsQueryResult, GroupsQueryBuilder, } from './social-groups-v2-group-groups.universal.js';
