"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebhookIdentityType = exports.Type = exports.StepKey = exports.SortOrder = exports.PrivacyStatus = exports.MembershipStatus = exports.IdentityType = exports.ContentType = exports.BMFeaturesBMFeatures = exports.AllowPolicy = exports.onGroupUpdated = exports.onGroupDescriptionChanged = exports.onGroupCoverChanged = exports.onGroupDeleted = exports.onGroupCreated = exports.queryGroups = exports.listGroups = exports.getGroupBySlug = exports.getGroup = exports.deleteGroup = exports.updateGroup = exports.createGroup = exports.__metadata = void 0;
const rename_all_nested_keys_1 = require("@wix/sdk-runtime/rename-all-nested-keys");
const float_1 = require("@wix/sdk-runtime/transformations/float");
const timestamp_1 = require("@wix/sdk-runtime/transformations/timestamp");
const transform_paths_1 = require("@wix/sdk-runtime/transformations/transform-paths");
const sdk_types_1 = require("@wix/sdk-types");
const social_groups_v2_group_groups_universal_js_1 = require("./social-groups-v2-group-groups.universal.js");
exports.__metadata = { PACKAGE_NAME: '@wix/groups' };
function createGroup(httpClient) {
    return (group, options) => (0, social_groups_v2_group_groups_universal_js_1.createGroup)(group, options, 
    // @ts-ignore
    { httpClient });
}
exports.createGroup = createGroup;
function updateGroup(httpClient) {
    return (_id, group, options) => (0, social_groups_v2_group_groups_universal_js_1.updateGroup)(_id, group, options, 
    // @ts-ignore
    { httpClient });
}
exports.updateGroup = updateGroup;
function deleteGroup(httpClient) {
    return (groupId) => (0, social_groups_v2_group_groups_universal_js_1.deleteGroup)(groupId, 
    // @ts-ignore
    { httpClient });
}
exports.deleteGroup = deleteGroup;
function getGroup(httpClient) {
    return (groupId, options) => (0, social_groups_v2_group_groups_universal_js_1.getGroup)(groupId, options, 
    // @ts-ignore
    { httpClient });
}
exports.getGroup = getGroup;
function getGroupBySlug(httpClient) {
    return (slug, options) => (0, social_groups_v2_group_groups_universal_js_1.getGroupBySlug)(slug, options, 
    // @ts-ignore
    { httpClient });
}
exports.getGroupBySlug = getGroupBySlug;
function listGroups(httpClient) {
    return (options) => (0, social_groups_v2_group_groups_universal_js_1.listGroups)(options, 
    // @ts-ignore
    { httpClient });
}
exports.listGroups = listGroups;
function queryGroups(httpClient) {
    return (options) => (0, social_groups_v2_group_groups_universal_js_1.queryGroups)(options, 
    // @ts-ignore
    { httpClient });
}
exports.queryGroups = queryGroups;
exports.onGroupCreated = (0, sdk_types_1.EventDefinition)('wix.social_groups.v2.group_created', true, (event) => (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(event, [
    {
        transformFn: timestamp_1.transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'entity.createdDate' },
            { path: 'entity.updatedDate' },
            { path: 'entity.recentActivityDate' },
            { path: 'entity.lastActivityDate' },
            { path: 'metadata.eventTime' },
        ],
    },
    {
        transformFn: float_1.transformRESTFloatToSDKFloat,
        paths: [
            { path: 'entity.details.logoPosition.x' },
            { path: 'entity.details.logoPosition.y' },
            { path: 'entity.details.mobileLogoPosition.x' },
            { path: 'entity.details.mobileLogoPosition.y' },
            { path: 'entity.coverImage.position.x' },
            { path: 'entity.coverImage.position.y' },
            { path: 'entity.coverImage.mobilePosition.x' },
            { path: 'entity.coverImage.mobilePosition.y' },
        ],
    },
])))();
exports.onGroupDeleted = (0, sdk_types_1.EventDefinition)('wix.social_groups.v2.group_deleted', true, (event) => (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(event, [
    {
        transformFn: timestamp_1.transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'undefined.createdDate' },
            { path: 'undefined.updatedDate' },
            { path: 'undefined.recentActivityDate' },
            { path: 'undefined.lastActivityDate' },
            { path: 'metadata.eventTime' },
        ],
    },
    {
        transformFn: float_1.transformRESTFloatToSDKFloat,
        paths: [
            { path: 'undefined.details.logoPosition.x' },
            { path: 'undefined.details.logoPosition.y' },
            { path: 'undefined.details.mobileLogoPosition.x' },
            { path: 'undefined.details.mobileLogoPosition.y' },
            { path: 'undefined.coverImage.position.x' },
            { path: 'undefined.coverImage.position.y' },
            { path: 'undefined.coverImage.mobilePosition.x' },
            { path: 'undefined.coverImage.mobilePosition.y' },
        ],
    },
])))();
exports.onGroupCoverChanged = (0, sdk_types_1.EventDefinition)('wix.social_groups.v2.group_group_cover_changed', true, (event) => (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(event, [
    {
        transformFn: timestamp_1.transformRESTTimestampToSDKTimestamp,
        paths: [{ path: 'metadata.eventTime' }],
    },
])))();
exports.onGroupDescriptionChanged = (0, sdk_types_1.EventDefinition)('wix.social_groups.v2.group_group_description_changed', true, (event) => (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(event, [
    {
        transformFn: timestamp_1.transformRESTTimestampToSDKTimestamp,
        paths: [{ path: 'metadata.eventTime' }],
    },
])))();
exports.onGroupUpdated = (0, sdk_types_1.EventDefinition)('wix.social_groups.v2.group_updated', true, (event) => (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(event, [
    {
        transformFn: timestamp_1.transformRESTTimestampToSDKTimestamp,
        paths: [
            { path: 'entity.createdDate' },
            { path: 'entity.updatedDate' },
            { path: 'entity.recentActivityDate' },
            { path: 'entity.lastActivityDate' },
            { path: 'metadata.eventTime' },
        ],
    },
    {
        transformFn: float_1.transformRESTFloatToSDKFloat,
        paths: [
            { path: 'entity.details.logoPosition.x' },
            { path: 'entity.details.logoPosition.y' },
            { path: 'entity.details.mobileLogoPosition.x' },
            { path: 'entity.details.mobileLogoPosition.y' },
            { path: 'entity.coverImage.position.x' },
            { path: 'entity.coverImage.position.y' },
            { path: 'entity.coverImage.mobilePosition.x' },
            { path: 'entity.coverImage.mobilePosition.y' },
        ],
    },
])))();
var social_groups_v2_group_groups_universal_js_2 = require("./social-groups-v2-group-groups.universal.js");
Object.defineProperty(exports, "AllowPolicy", { enumerable: true, get: function () { return social_groups_v2_group_groups_universal_js_2.AllowPolicy; } });
Object.defineProperty(exports, "BMFeaturesBMFeatures", { enumerable: true, get: function () { return social_groups_v2_group_groups_universal_js_2.BMFeaturesBMFeatures; } });
Object.defineProperty(exports, "ContentType", { enumerable: true, get: function () { return social_groups_v2_group_groups_universal_js_2.ContentType; } });
Object.defineProperty(exports, "IdentityType", { enumerable: true, get: function () { return social_groups_v2_group_groups_universal_js_2.IdentityType; } });
Object.defineProperty(exports, "MembershipStatus", { enumerable: true, get: function () { return social_groups_v2_group_groups_universal_js_2.MembershipStatus; } });
Object.defineProperty(exports, "PrivacyStatus", { enumerable: true, get: function () { return social_groups_v2_group_groups_universal_js_2.PrivacyStatus; } });
Object.defineProperty(exports, "SortOrder", { enumerable: true, get: function () { return social_groups_v2_group_groups_universal_js_2.SortOrder; } });
Object.defineProperty(exports, "StepKey", { enumerable: true, get: function () { return social_groups_v2_group_groups_universal_js_2.StepKey; } });
Object.defineProperty(exports, "Type", { enumerable: true, get: function () { return social_groups_v2_group_groups_universal_js_2.Type; } });
Object.defineProperty(exports, "WebhookIdentityType", { enumerable: true, get: function () { return social_groups_v2_group_groups_universal_js_2.WebhookIdentityType; } });
//# sourceMappingURL=social-groups-v2-group-groups.public.js.map