"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.queryGroups = exports.listGroups = exports.getGroupBySlug = exports.getGroup = exports.deleteGroup = exports.updateGroup = exports.createGroup = exports.WebhookIdentityType = exports.BMFeaturesBMFeatures = exports.MembershipStatus = exports.SortOrder = exports.ContentType = exports.IdentityType = exports.PrivacyStatus = exports.StepKey = exports.AllowPolicy = exports.Type = void 0;
const transform_error_1 = require("@wix/sdk-runtime/transform-error");
const query_builder_1 = require("@wix/sdk-runtime/query-builder");
const rename_all_nested_keys_1 = require("@wix/sdk-runtime/rename-all-nested-keys");
const ambassadorWixSocialGroupsV2Group = __importStar(require("./social-groups-v2-group-groups.http.js"));
// @ts-ignore
const transform_paths_1 = require("@wix/sdk-runtime/transformations/transform-paths");
var Type;
(function (Type) {
    Type["UNKNOWN"] = "UNKNOWN";
    Type["ADMIN_APPROVAL"] = "ADMIN_APPROVAL";
    Type["PAID_PLANS"] = "PAID_PLANS";
    Type["EVENTS"] = "EVENTS";
})(Type || (exports.Type = Type = {}));
var AllowPolicy;
(function (AllowPolicy) {
    AllowPolicy["UNKNOWN"] = "UNKNOWN";
    AllowPolicy["OWNER_AND_ADMINS"] = "OWNER_AND_ADMINS";
    AllowPolicy["OWNER"] = "OWNER";
    AllowPolicy["ALL_MEMBERS"] = "ALL_MEMBERS";
})(AllowPolicy || (exports.AllowPolicy = AllowPolicy = {}));
var StepKey;
(function (StepKey) {
    StepKey["UNKNOWN"] = "UNKNOWN";
    StepKey["CREATE_POST"] = "CREATE_POST";
    StepKey["REACT_TO_POST"] = "REACT_TO_POST";
    StepKey["INVITE_MEMBERS"] = "INVITE_MEMBERS";
})(StepKey || (exports.StepKey = StepKey = {}));
var PrivacyStatus;
(function (PrivacyStatus) {
    /** Undefined group privacy status. */
    PrivacyStatus["UNKNOWN"] = "UNKNOWN";
    /** Anyone can see the group and its content. Anyone can join the group. */
    PrivacyStatus["PUBLIC"] = "PUBLIC";
    /** Anyone can see the group, but only members can see its content. New members must submit a `Join Group Request`. */
    PrivacyStatus["PRIVATE"] = "PRIVATE";
    /** Only admins and members can see the group. New members can only be added by other members. */
    PrivacyStatus["SECRET"] = "SECRET";
})(PrivacyStatus || (exports.PrivacyStatus = PrivacyStatus = {}));
var IdentityType;
(function (IdentityType) {
    /** Wix user. */
    IdentityType["USER"] = "USER";
    /** Wix member. */
    IdentityType["MEMBER"] = "MEMBER";
})(IdentityType || (exports.IdentityType = IdentityType = {}));
var ContentType;
(function (ContentType) {
    ContentType["PLAIN_TEXT"] = "PLAIN_TEXT";
    ContentType["DRAFTJS"] = "DRAFTJS";
    ContentType["RICH_CONTENT"] = "RICH_CONTENT";
})(ContentType || (exports.ContentType = ContentType = {}));
var SortOrder;
(function (SortOrder) {
    SortOrder["ASC"] = "ASC";
    SortOrder["DESC"] = "DESC";
})(SortOrder || (exports.SortOrder = SortOrder = {}));
var MembershipStatus;
(function (MembershipStatus) {
    MembershipStatus["NONE"] = "NONE";
    MembershipStatus["JOINED"] = "JOINED";
    MembershipStatus["PENDING"] = "PENDING";
})(MembershipStatus || (exports.MembershipStatus = MembershipStatus = {}));
var BMFeaturesBMFeatures;
(function (BMFeaturesBMFeatures) {
    BMFeaturesBMFeatures["BM_FEATURES_UNKNOWN"] = "BM_FEATURES_UNKNOWN";
    BMFeaturesBMFeatures["BM_FEATURES_GENERATE_TOPICS"] = "BM_FEATURES_GENERATE_TOPICS";
    BMFeaturesBMFeatures["BM_FEATURES_GENERATE_QUESTIONS"] = "BM_FEATURES_GENERATE_QUESTIONS";
})(BMFeaturesBMFeatures || (exports.BMFeaturesBMFeatures = BMFeaturesBMFeatures = {}));
var WebhookIdentityType;
(function (WebhookIdentityType) {
    WebhookIdentityType["UNKNOWN"] = "UNKNOWN";
    WebhookIdentityType["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
    WebhookIdentityType["MEMBER"] = "MEMBER";
    WebhookIdentityType["WIX_USER"] = "WIX_USER";
    WebhookIdentityType["APP"] = "APP";
})(WebhookIdentityType || (exports.WebhookIdentityType = WebhookIdentityType = {}));
/**
 * Creates a group.
 *
 * When a group is created, the newly created group is added to the [Groups List](https://support.wix.com/en/article/wix-groups-about-your-groups-pages#groups-group-list) page
 * of a site.
 *
 * Specify a `creatorId` to set the group's creator. The group's creator will automatically become a group admin, see Terminology ([REST](https://dev.wix.com/docs/rest/crm/community/groups/terminology) | [SDK](https://dev.wix.com/docs/sdk/backend-modules/groups/terminology)).
 *
 * Wix users determine who can create a group.
 * This setting can be found in [a site's Dashboard](https://www.wix.com/my-account/site-selector/?buttonText=Select%20Site&title=Select%20a%20Site&autoSelectOnSingleSite=true&actionUrl=https:%2F%2Fwww.wix.com%2Fdashboard%2F%7B%7BmetaSiteId%7D%7D%2Fwix-groups/settings?) under **Groups > General Settings > Group Creation**.
 * If set to **members with approval**, site members can create a group with the Create Group method, and the group becomes a `createRequest` with a status of `PENDING`.
 * A Wix user either approves or rejects the request to create a group.
 * If set to **all site members**, site members can create a group with the Create Group method and no approval is required.
 * If set to **only admins**, only Wix users can create a group with the Create Group method.
 * Default is set to **members with approval**.
 * @param group - Group to create.
 * @public
 * @requiredField group
 * @param options - Optional fields for group creation.
 * @returns Created group.
 * @fqn wix.social.groups.api.v2.GroupsService.CreateGroup
 */
async function createGroup(group, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        group: group,
        creatorId: options?.creatorId,
        contentType: options?.contentType,
    });
    const reqOpts = ambassadorWixSocialGroupsV2Group.createGroup(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data)?.group;
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                group: '$[0]',
                creatorId: '$[1].creatorId',
                contentType: '$[1].contentType',
            },
            singleArgumentUnchanged: false,
        }, ['group', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.createGroup = createGroup;
/**
 * Updates a group.
 *
 * When a public or private group's name is updated, the slug is updated to reflect the new group name.
 * Only group admins can update their group.
 *
 * > **Notes:**
 * > + When `group.privacyStatus` is updated from `PRIVATE` to `PUBLIC`, all pending group join requests are automatically approved.
 * > + When `group.privacyStatus` is updated from `PRIVATE` to `SECRET`, all pending group join requests are automatically rejected.
 * @param _id - Group ID.
 * @public
 * @requiredField _id
 * @requiredField group
 * @returns Updated group.
 * @fqn wix.social.groups.api.v2.GroupsService.UpdateGroup
 */
async function updateGroup(_id, group, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[3];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        group: { ...group, id: _id },
        contentType: options?.contentType,
    });
    const reqOpts = ambassadorWixSocialGroupsV2Group.updateGroup(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data)?.group;
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: { group: '$[1]' },
            explicitPathsToArguments: {
                'group.id': '$[0]',
                contentType: '$[2].contentType',
            },
            singleArgumentUnchanged: false,
        }, ['_id', 'group', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.updateGroup = updateGroup;
/**
 * Hides a group from the [Groups List](https://support.wix.com/en/article/wix-groups-about-your-groups-pages#groups-group-list) or cancels a group request.
 *
 * >**Notes:**
 * > + Only group admins can delete their group.
 * > + The group will no longer be visible in the live site or the dashboard.
 * > + It is not possible to restore a deleted group with the Update Group method.
 * > + It is still possible to retrieve the group with the Get Group, List Groups, and Query Groups methods.
 * @param groupId - ID of the group to delete.
 * @public
 * @requiredField groupId
 * @fqn wix.social.groups.api.v2.GroupsService.DeleteGroup
 */
async function deleteGroup(groupId) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({ groupId: groupId });
    const reqOpts = ambassadorWixSocialGroupsV2Group.deleteGroup(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: { groupId: '$[0]' },
            singleArgumentUnchanged: false,
        }, ['groupId']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.deleteGroup = deleteGroup;
/**
 * Retrieves a group.
 *
 * For groups with `group.privacyStatus` set to `SECRET`, only group admins and group members can see the group and its content.
 * @param groupId - ID of the group to retrieve.
 * @public
 * @requiredField groupId
 * @returns Retrieved group.
 * @fqn wix.social.groups.api.v2.GroupsService.GetGroup
 */
async function getGroup(groupId, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        groupId: groupId,
        contentType: options?.contentType,
    });
    const reqOpts = ambassadorWixSocialGroupsV2Group.getGroup(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data)?.group;
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                groupId: '$[0]',
                contentType: '$[1].contentType',
            },
            singleArgumentUnchanged: false,
        }, ['groupId', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.getGroup = getGroup;
/**
 * Retrieves a group by slug.
 *
 * The slug is the end of a group's URL that refers to a specific group.
 * For example, if a group's URL is `https:/example.com/groups/{my-fitness-group}`, the slug is `my-fitness-group`.
 * Slugs are case-sensitive. It is generally based on the group name, but for secret groups it is an autogenerated string of characters,
 * for example, `https:/example.com/groups/{5D3yTX}`.
 *
 * For groups with `group.privacyStatus` set to `SECRET`, only group admins and group members can see the group and its content.
 * @param slug - Unique part of the group's URL. For example, if a group's URL is `https:/example.com/groups/{my-fitness-group}`, the slug is `my-fitness-group`. Case-sensitive.
 * @public
 * @requiredField slug
 * @fqn wix.social.groups.api.v2.GroupsService.GetGroupBySlug
 */
async function getGroupBySlug(slug, options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[2];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        slug: slug,
        autoInviteId: options?.autoInviteId,
        contentType: options?.contentType,
    });
    const reqOpts = ambassadorWixSocialGroupsV2Group.getGroupBySlug(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                slug: '$[0]',
                autoInviteId: '$[1].autoInviteId',
                contentType: '$[1].contentType',
            },
            singleArgumentUnchanged: false,
        }, ['slug', 'options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.getGroupBySlug = getGroupBySlug;
/**
 * Retrieves up to 100 groups.
 *
 *
 * Default sorts by `_createdDate` in descending order. For `SECRET` groups, only group admins and group members can see a list of groups and their content.
 *
 * > **Note:** This function's parameters are positional, and must be specified in the sequence shown in the syntax below. When specifying a parameter, use `null` as a placeholder for any unspecified parameters. For example, to specify limit only, call `listGroups(paging, null)`.
 * @public
 * @param options - Limit and offset options.
 * @fqn wix.social.groups.api.v2.GroupsService.ListGroups
 */
async function listGroups(options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    const payload = (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
        limit: options?.limit,
        offset: options?.offset,
        contentType: options?.contentType,
    });
    const reqOpts = ambassadorWixSocialGroupsV2Group.listGroups(payload);
    sideEffects?.onSiteCall?.();
    try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)(result.data);
    }
    catch (err) {
        const transformedError = (0, transform_error_1.transformError)(err, {
            spreadPathsToArguments: {},
            explicitPathsToArguments: {
                limit: '$[0].limit',
                offset: '$[0].offset',
                contentType: '$[0].contentType',
            },
            singleArgumentUnchanged: false,
        }, ['options']);
        sideEffects?.onError?.(err);
        throw transformedError;
    }
}
exports.listGroups = listGroups;
/**
 * Retrieves up to 100 groups, given the provided paging, filtering, and sorting.
 *
 * Supported fields for filtering:
 * - `title`
 *
 * Supported fields for sorting:
 * - `title`
 * - `createdDate`
 * - `membersCount`
 * - `recentActivityDate`
 *
 * For groups with `group.privacyStatus` set to `SECRET`, only group admins and group members can see the group and its content.
 * @public
 * @fqn wix.social.groups.api.v2.GroupsService.QueryGroups
 */
function queryGroups(options) {
    // @ts-ignore
    const { httpClient, sideEffects } = arguments[1];
    return (0, query_builder_1.queryBuilder)({
        func: async (payload) => {
            const reqOpts = ambassadorWixSocialGroupsV2Group.queryGroups({
                ...payload,
                ...(options ?? {}),
            });
            sideEffects?.onSiteCall?.();
            try {
                const result = await httpClient.request(reqOpts);
                sideEffects?.onSuccess?.(result);
                return result;
            }
            catch (err) {
                sideEffects?.onError?.(err);
                throw err;
            }
        },
        requestTransformer: (query) => {
            const args = [query, options];
            return (0, rename_all_nested_keys_1.renameKeysFromSDKRequestToRESTRequest)({
                ...args?.[1],
                query: args?.[0],
            });
        },
        responseTransformer: ({ data }) => {
            const transformedData = (0, rename_all_nested_keys_1.renameKeysFromRESTResponseToSDKResponse)((0, transform_paths_1.transformPaths)(data, []));
            return {
                items: transformedData?.groups,
                pagingMetadata: transformedData?.metadata,
            };
        },
        errorTransformer: (err) => {
            const transformedError = (0, transform_error_1.transformError)(err, {
                spreadPathsToArguments: {},
                explicitPathsToArguments: { query: '$[0]' },
                singleArgumentUnchanged: false,
            });
            throw transformedError;
        },
        pagingMethod: 'OFFSET',
        transformationPaths: {},
    });
}
exports.queryGroups = queryGroups;
//# sourceMappingURL=social-groups-v2-group-groups.universal.js.map