import { createGroup as publicCreateGroup, updateGroup as publicUpdateGroup, deleteGroup as publicDeleteGroup, getGroup as publicGetGroup, getGroupBySlug as publicGetGroupBySlug, listGroups as publicListGroups, queryGroups as publicQueryGroups, } from './social-groups-v2-group-groups.public.js';
import { createRESTModule } from '@wix/sdk-runtime/rest-modules';
import { createEventModule } from '@wix/sdk-runtime/event-definition-modules';
import { onGroupCreated as publicOnGroupCreated } from './social-groups-v2-group-groups.public.js';
import { onGroupDeleted as publicOnGroupDeleted } from './social-groups-v2-group-groups.public.js';
import { onGroupCoverChanged as publicOnGroupCoverChanged } from './social-groups-v2-group-groups.public.js';
import { onGroupDescriptionChanged as publicOnGroupDescriptionChanged } from './social-groups-v2-group-groups.public.js';
import { onGroupUpdated as publicOnGroupUpdated } from './social-groups-v2-group-groups.public.js';
export const createGroup = /*#__PURE__*/ createRESTModule(publicCreateGroup);
export const updateGroup = /*#__PURE__*/ createRESTModule(publicUpdateGroup);
export const deleteGroup = /*#__PURE__*/ createRESTModule(publicDeleteGroup);
export const getGroup = /*#__PURE__*/ createRESTModule(publicGetGroup);
export const getGroupBySlug = /*#__PURE__*/ createRESTModule(publicGetGroupBySlug);
export const listGroups = /*#__PURE__*/ createRESTModule(publicListGroups);
export const queryGroups = /*#__PURE__*/ createRESTModule(publicQueryGroups);
/**
 * Triggered when a group is created.
 */
export const onGroupCreated = createEventModule(publicOnGroupCreated);
/**
 * Triggered when a group is deleted.
 */
export const onGroupDeleted = createEventModule(publicOnGroupDeleted);
/**
 * Triggered when a group's logo is changed.
 */
export const onGroupCoverChanged = createEventModule(publicOnGroupCoverChanged);
/**
 * Triggered when a group's description is changed.
 */
export const onGroupDescriptionChanged = createEventModule(publicOnGroupDescriptionChanged);
/**
 * Triggered when a group is updated. See payload for more information about the specific trigger.
 */
export const onGroupUpdated = createEventModule(publicOnGroupUpdated);
export { Type, AllowPolicy, StepKey, PrivacyStatus, IdentityType, ContentType, SortOrder, MembershipStatus, BMFeaturesBMFeatures, WebhookIdentityType, } from './social-groups-v2-group-groups.universal.js';
//# sourceMappingURL=social-groups-v2-group-groups.context.js.map